import React, { Component } from 'react';
import { ThemeProvider } from 'styled-components';
import createCard from '../../createCard';
import propTypes from './propTypes';
import BlockquoteView from './BlockquoteView';
import PullquoteView from './PullquoteView';
import { TYPE, FLOAT } from './enums';

class QuoteCardView extends Component {
  static TYPE = TYPE;
  static FLOAT = FLOAT;
  static propTypes = propTypes;

  getComponent() {
    switch (this.props.type) {
      case TYPE.PULLQUOTE:
        return PullquoteView;
      default:
        return BlockquoteView;
    }
  }

  render() {
    const Comp = this.getComponent();
    return (
      <ThemeProvider theme={{}}>
        <Comp {...this.props} />
      </ThemeProvider>
    );
  }
}

export default createCard({
  name: 'QuoteCard',
  renderWith: QuoteCardView,
});
